<template>
  <div class="main-wrapper" style="margin: 20px 30px;">
    <v-btn
      tile
      class="mr-4 btn-yellow font-size-11"
      @click="
        (getInfoProyecto()),
        (disabledInputs = false),
          (cecosEncontrados = []),
          (proyectos = []),
          (fases = []),
          (dialog = true),
          (editingVisit = false),
          cleanForm()
      "
    >
      <img src="@/assets/img/mas.svg" class="btnIco" />
      Nueva visita
    </v-btn>
    <v-dialog v-model="dialog" persistent max-width="800">
      <v-card>
        <div class="contSecc">
          <div class="titSec font-size-13" v-if="!editingVisit">Nueva visita</div>
          <div class="titSec font-size-13" v-if="editingVisit">Editar visita</div>
          <div class="gris">
            <div class="titCol titDialog">Ingresa la información para realizar una nueva visita</div>
            <div class="divCol spaceCol">
              <div class="col12">
                Usuario a asignar:
                <br />
                <div class="pRelative">
                  <input
                    type="text"
                    id="busca"
                    placeholder="Buscar por número de empleado"
                    v-model="visitShowed.nombre"
                    @keyup="validateForm"
                  />
                  <input type="submit" class="buscar" value @click="getUsuarios()" />
                </div>
              </div>
            </div>
            <div class="divCol spaceCol">
              <div class="col6">
                Proyecto:
                <br />
                <v-select
                  :items="proyectos"
                  item-value="idProyecto"
                  item-text="nombreProyecto"
                  label
                  solo
                  :readonly="disabledInputs"
                  v-model="visitShowed.proyecto"
                  return-object
                  @change="getInfoFases(), getCecos() , validateForm()"
                  color="#ffeeb2"
                ></v-select>
              </div>
              <div class="col6">
                Sucursal:
                <br />
                <input
                  v-if="editingVisit"
                  type="text"
                  :readonly="disabledInputs"
                  placeholder
                  v-model="visitShowed.ceco.ceco"
                  @keyup="validateForm"
                />

                <v-autocomplete
                  v-else
                  ref="autoCeco"
                  v-model="visitShowed.ceco"
                  :items="cecosEncontrados"
                  :readonly="disabledInputs"
                  item-value="idCeco"
                  item-text="ceco"
                  placeholder="Busca una sucursal"
                  :search-input.sync="cecoIngresado"
                  
                  @change="validateForm()"
                  :cache-items="false"
                  class="custom-autocomplite"
                ></v-autocomplete>
              </div>
            </div>
            <div class="divCol spaceCol">
              <div class="col6">
                Fase:
                <br />
                <v-select
                  :items="fases"
                  item-value="idFase"
                  item-text="nombreFase"
                  label
                  solo
                  :readonly="disabledInputs"
                  v-model="visitShowed.fase"
                  return-object
                  @change="validateForm"
                ></v-select>
              </div>
              <div class="col6" style="text-align: initial;">
                <v-menu
                  v-model="menu"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on, attrs }">
                    Fecha de visita:
                    <br />
                    <input
                      type="text"
                      readonly
                      class="date datapicker1"
                      placeholder="dd/mm/aaaa"
                      v-model="visitShowed.start"
                      v-bind="attrs"
                      v-on="on"
                      @change="validateForm()"
                    />
                  </template>
                  <v-date-picker
                    v-model="visitShowed.start"
                    @change="validateForm()"
                    @input="menu = false"
                    header-color="#ffc900"
                    color="#ffeeb2"
                  ></v-date-picker>
                </v-menu>
              </div>
            </div>
          </div>
        </div>
        <div class="btnCenter">
          <v-btn
            color="green darken-1"
            text
            tile
            class="mr-8 btn btn-gray"
            @click="dialog = false"
          >Cancelar</v-btn>
          <v-btn
            color="green darken-1"
            text
            tile
            class="btn btn-yellow"
            @click="(dialog = false), addVisit()"
            v-if="!editingVisit"
            :class="{ desac: !activeButton }"
          >Crear visita</v-btn>
          <v-btn
            color="green darken-1"
            text
            tile
            class="btn btn-yellow"
            @click="(dialog = false), saveVisit()"
            v-if="editingVisit"
          >Guardar cambios</v-btn>
        </div>
      </v-card>
    </v-dialog>
    <v-row class="fill-height">
      <v-col>
        <v-sheet height="64">
          <v-toolbar flat color="white">
            <div class="arrows-container">
              <v-btn text medium color="grey" @click="prev">
                <v-icon large>mdi-chevron-left</v-icon>
              </v-btn>
              <v-btn text medium color="grey" @click="next">
                <v-icon large>mdi-chevron-right</v-icon>
              </v-btn>
            </div>

            <v-toolbar-title class="font-size-2" v-if="$refs.calendar && !showTittleDay">
              <span style="color: #000">{{ $refs.calendar.title }}</span>
              <span v-if="showWeek" style="color: rgb(119 119 119)">(Semana {{ week }})</span>
            </v-toolbar-title>
            <v-toolbar-title class="font-size-2" v-if="showTittleDay">
              <span style="color: #000">{{ tittleDay }}</span>
            </v-toolbar-title>

            <div>
              <v-btn-toggle v-model="groupButtons" mandatory>
                <v-btn @click="selectMonth" class="font-size-11 w90px">Mes</v-btn>
                <v-btn @click="selectWeek" class="font-size-11 w90px">Semana</v-btn>
                <v-btn @click="selectDay" class="font-size-11 w90px">Día</v-btn>
              </v-btn-toggle>
            </div>
          </v-toolbar>
        </v-sheet>
        <v-sheet height="700" style="margin-top: 8px;">
          <v-calendar
            color="#ffeeb2"
            ref="calendar"
            v-model="focus"
            :events="events"
            :event-color="getEventColor"
            :type="type"
            :short-weekdays="false"
            :weekdays="weekdays"
            @click:event="viewDay($event)"
            @click:more="viewDayMore($event)"
            @click:date="updateDateSelected"
            @change="updateRange"
          >
            <template v-slot:event="{ event }">
              <div class="event-content-month" layout="column" v-if="templateMonth">
                <span class="dot" :style="{ backgroundColor: getColor(event.idNegocio) }"></span>
                <div class="black--text">
                  {{ getNumEco(event.idCeco) }}
                  <strong>{{ event.ceco }}</strong>
                </div>
              </div>

              <div class="separator event-container" layout="column" v-if="templateWeek">
                <div class="event-content-week">
                  <span class="dot" :style="{ backgroundColor: getColor(event.idNegocio) }"></span>
                  <div>
                    <div class="black--text content-space">
                      {{ event.negocio }} - {{ getNumEco(event.idCeco) }}
                      <br />
                      <strong>{{ event.nombreProyecto }}</strong>
                      <br />
                      ({{ event.nombreFase }})
                      <br />
                    </div>
                    <div class="black--text content-space">{{ event.ceco }}</div>
                    <div class="black--text content-space">{{ event.nombreResponsable }}</div>
                  </div>
                </div>
              </div>

              <div class="separator event-container" layout="column" v-if="templateDay">
                <div class="event-content-day">
                  <span class="dot" :style="{ backgroundColor: getColor(event.idNegocio) }"></span>
                  <div class="w-100 d-flex-sb">
                    <div class="black--text content-space">
                      {{ event.negocio }} - {{ getNumEco(event.idCeco) }} -
                      {{ event.ceco }}
                      <br />
                      <strong>{{ event.nombreProyecto }}</strong>
                      ({{
                      event.nombreFase
                      }})
                      <br />
                      <strong>{{ event.nombreResponsable }}</strong>
                    </div>
                    <div v-if="event.estatus != 1" class="buttons-container">
                      <div class="edit" @click="(disabledInputs = true), editVisit(event)">
                        <img src="@/assets/img/icoEditar.svg" />

                        <span>Editar visita</span>
                      </div>
                      <div class="delete" @click="deleteVisit(event)">
                        <img src="@/assets/img/icoEliminar.svg" />
                        <span>Eliminar visita</span>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </template>
          </v-calendar>
        </v-sheet>
      </v-col>
    </v-row>
    <strong>Simbología</strong>
    <div class="simbologiaContainer">
      <div class="element">
        <span class="dot" :style="{ backgroundColor: colors.orange }"></span>
        <strong>PPR - Presta Prenda</strong>
      </div>
      <div class="element">
        <span class="dot" :style="{ backgroundColor: colors.green }"></span>
        <strong>DAZ - Dinero Azteca</strong>
      </div>
      <div class="element">
        <span class="dot" :style="{ backgroundColor: colors.cyan }"></span>
        <strong>ITK - Italika</strong>
      </div>
      <div class="element">
        <span class="dot" :style="{ backgroundColor: colors.yellow }"></span>
        <strong>EKT - Elektra</strong>
      </div>
      <div class="element">
        <span class="dot" :style="{ backgroundColor: colors.blue }"></span>
        <strong>OCC - Oficina de Crédito y Cobranza</strong>
      </div>
    </div>

    <v-dialog v-model="dialogInfo" persistent max-width="800">
      <v-card>
        <div class="contSecc">
          <div
            class="titSec font-size-13"
            :style="{ borderColor: dialogContentInfo.color }"
          >{{ dialogContentInfo.title }}</div>
          <div class="gris">
            <div class="infoContainer">
              <img :src="getImgUrl(dialogContentInfo.img)" class="imgDialogInfo" />
              <div
                v-if="dialogContentInfo.text1.show"
                :class="{ strong: dialogContentInfo.text1.strong }"
              >{{ dialogContentInfo.text1.text }}</div>
              <div
                v-if="dialogContentInfo.text2.show"
                :class="{ strong: dialogContentInfo.text2.strong }"
              >{{ dialogContentInfo.text2.text }}</div>
              <div
                v-if="dialogContentInfo.text3.show"
                :class="{ strong: dialogContentInfo.text3.strong }"
              >{{ dialogContentInfo.text3.text }}</div>
            </div>
          </div>
        </div>
        <div class="btnCenter">
          <v-btn
            color="green darken-1"
            text
            tile
            class="mr-8 btn btn-gray"
            @click="dialogInfo = false"
            v-if="dialogContentInfo.secundaryBtn"
          >{{ dialogContentInfo.secundaryBtnText }}</v-btn>
          <v-btn
            color="green darken-1"
            text
            tile
            class="btn btn-yellow"
            @click="(dialogInfo = false), dialogActions($event)"
          >{{ dialogContentInfo.primaryBtnText }}</v-btn>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import router from "@/router";
import store from "@/store";
import axios from "axios";
import moment from "moment";
import { cos } from '@amcharts/amcharts4/.internal/core/utils/Math';
export default {
  components: {},
  created() {},
  data() {
    return {
      startDate: "",
      endDate: "",
      cecoIngresado: "",
      cecoSeleccionado: "",
      cecosEncontrados: [],
      usuarioEncontrado: "",
      disabledInputs: true,
      dialog: false,
      dialogInfo: false,
      dialogContentInfo: {
        title: "",
        color: "",
        img: "",
        text1: { text: "", show: true, strong: false },
        text2: { text: "", show: true, strong: false },
        text3: { text: "", show: true, strong: false },
        secundaryBtn: false,
        secundaryBtnText: "",
        primaryBtnText: ""
      },
      datePicker: new Date().toISOString().substr(0, 10),
      menu: false,
      groupButtons: undefined,
      focus: "",
      type: "month",
      weekdays: [1, 2, 3, 4, 5, 6, 0],
      eventsCompleted: [],
      events: [],
      colors: {
        orange: "#ff7500",
        green: "#01c458",
        cyan: "#00b5dd",
        yellow: "#ffca00",
        blue: "#001d61"
      },
      week: undefined,
      showWeek: false,
      showTittleDay: false,
      selectedDate: new Date(),
      tittleDay: "",
      templateMonth: true,
      templateWeek: false,
      templateDay: false,
      visitShowed: {
        ceco: "0000",
        negocio: "ITK",
        name: "",
        proyecto: "",
        start: new Date().toISOString().substr(0, 10),
        sucursal: "",
        nombre: "",
        color: "transparent",
        timed: false,
        dotColor: "#00b5dd"
      },
      editingVisit: false,
      selectedVisit: undefined,
      fases: [],
      proyectos: [],
      activeButton: false
    };
  },
  mounted() {},
  methods: {
    getColor(negocio) {
      var color = "#000";

      if (negocio == 21) {
        //EKT
        color = this.colors.yellow;
      } else if (negocio == 23) {
        //OCC
        color = this.colors.blue;
      } else if (negocio == 25) {
        //DAZ
        color = this.colors.green;
      } else if (negocio == 26) {
        //PPR
        color = this.colors.orange;
      }

      return color;
    },
    getNumEco(ceco) {
      var res = ("" + ceco).substring(2);
      return res;
    },

    actualizaCecos() {
      //console.log("Entre para llenar los cecos");
      if (this.cecoIngresado != null && this.cecoIngresado.length > 1) {
        //this.getCecos();
      } else if (this.textoIngresado == null || this.textoIngresado == "") {
        //this.cecosEncontrados = [];
        this.fases = [];
        //this.proyectos = [];
      }
    },
    getCecos() {

    

      axios
        .post("ceco/secure/post/ceco/gen", {
          //id_veco: this.cecoIngresado
          id_ceco: null,
          idCanal: this.visitShowed.proyecto.idNegocio
        })
        .then(response => {
         
          if (response) {
            if (response.status === 200) {
              this.cecosEncontrados = [];
              for (var i = 0; i < response.data.data.length; i++) {
                this.cecosEncontrados.push({
                  ceco:
                    response.data.data[i].descripcion +
                    " - " +
                    response.data.data[i].id_ceco,
                  idCeco: response.data.data[i].id_ceco
                });
              }
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    getUsuarios() {
      this.usuarioEncontrado = "";
      axios
        .get("/usuario/secure/get/" + this.visitShowed.nombre)
        .then(response => {
          if (response) {
            if (response.status === 200) {
              if (response.data.data != undefined) {
                this.usuarioEncontrado = {
                  id_usuario: response.data.data.id_usuario,
                  id_ceco: response.data.data.id_ceco,
                  nombre_usuario: response.data.data.nombre_usuario,
                  activo: response.data.data.activo,
                  dato_busqueda:
                    response.data.data.id_usuario +
                    " - " +
                    response.data.data.nombre_usuario
                };

                this.visitShowed.nombre = this.usuarioEncontrado.dato_busqueda;
                this.visitShowed.idUsuario = this.usuarioEncontrado.id_usuario;
              }
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    getInfoProyecto() {
      axios
        //.get("/asignacion/secure/get/ceco/" + this.visitShowed.ceco)
        .get("/asignacion/secure/get/ceco/0",)
        .then(response => {
          if (response) {
            if (response.status === 200) {
              //this.proyectos = [];
              this.proyectos = response.data.data;
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    getInfoFases() {
      //alert(JSON.stringify(this.visitShowed.proyecto))
      axios
        .post("/asignacion/secure/post/fases", {
          idProyecto: this.visitShowed.proyecto.idProyecto,
          ceco: this.visitShowed.ceco
        })
        .then(response => {
          if (response) {
            if (response.status === 200) {
              this.fases = [];
              this.fases = response.data.data;

              //alert(JSON.stringify(this.fases))
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    getAsignaciones(fechaInicio, fechaFin) {
      axios
        .post(
          "/asignacion/secure/post/obtiene/informacionCalendario",

          {
            fecha: fechaInicio + "" + fechaFin
          }
        )
        .then(response => {
          if (response) {
            if (response.status === 200) {
              this.events = [];

              this.addEvents(response.data.data.listaAsignaciones, false);
              this.addEvents(response.data.data.listaSoftHistorico, true);
            }
          }
        })
        .catch(error => {
          //console.log(error);
        })
        .finally(function() {});
    },
    eliminaAsignacion() {
      axios
        .delete("/asignacion/secure/delete/elimina/asignaciones", {
          data: {
            idProyecto: this.selectedVisit.idProyecto,
            ceco: this.selectedVisit.idCeco
          }
        })
        .then(response => {
          if (response) {
            if (response.status === 200) {
              this.getAsignaciones(this.startDate, this.endDate);
            } else {
              null; // falta dialog de error en eliminacion
            }
          }
        })
        .catch(error => {
          //this.errorEliminacionVisita()
        })
        .finally(function() {});
    },
    addEvents(data, historico) {
      if (data != null && data.length > 0) {
        Object.keys(data).forEach(key => {
          let objOfArray = data[key];

          let obj = {
            idProyecto: objOfArray.idProyecto,
            ceco: objOfArray.ceco,
            nombreProyecto: objOfArray.nombreProyecto,
            negocio: objOfArray.negocio,
            idAgrupa: objOfArray.idAgrupa,
            idUsuario: objOfArray.idUsuario,
            nombreResponsable: objOfArray.nombreResponsable,
            idFase: objOfArray.idFase,
            ordenFase: objOfArray.ordenFase,
            nombreFase: objOfArray.nombreFase,
            idCeco: objOfArray.idCeco,
            numSemana: objOfArray.numSemana,
            start: objOfArray.start,
            idNegocio: objOfArray.idNegocio,
            estatus: historico == true ? 1 : 0
          };

          this.events.push(obj);
        });
      }
    },

    getImgUrl(img) {
      if (img) {
        var images = require.context("@/assets/img/", false, /\.svg$/);
        //var images = ""
        return images("./" + img + ".svg");
      }
    },
    viewDay(e) {
      this.focus = e.day.date;
      this.type = "day";
      this.showWeek = false;
      this.selectedDate = new Date(e.day.date + "T00:00:00");
      this.selectDay();
      this.showTittleDay = true;
      this.groupButtons = 2;
    },
    viewDayMore(e) {
      let strMonth = "" + e.month;
      if (strMonth.length === 1) strMonth = "0" + strMonth;
      let date = "" + e.year + "-" + strMonth + "-" + e.day;
      this.focus = date;
      this.type = "day";
      this.showWeek = false;
      this.selectedDate = new Date(date + "T00:00:00");
      this.selectDay();
      this.showTittleDay = true;
      this.groupButtons = 2;
    },
    getEventColor(event) {
      if (event.estatus == 1) {
        return "#ffe3cc";
      } else {
        return "transparent";
      }
    },
    setToday() {
      this.focus = "";
    },
    prev() {
      this.$refs.calendar.prev();
      this.updateDateMove(false);
    },
    next() {
      this.$refs.calendar.next();
      this.updateDateMove(true);
    },
    updateRange({ start, end }) {
      //alert(moment(start.date).format('DDMMYYYY')+"-"+ moment(end.date).format('DDMMYYYY'))
      this.startDate = moment(start.date).format("DDMMYYYY");
      this.endDate = moment(end.date).format("DDMMYYYY");

      this.getAsignaciones(this.startDate, this.endDate);
    },
    selectWeek() {
      this.week = this.selectedDate.getWeek();
      this.type = "week";
      this.showWeek = true;
      this.showTittleDay = false;
      this.templateMonth = false;
      this.templateWeek = true;
      this.templateDay = false;
    },
    selectMonth() {
      this.type = "month";
      this.showWeek = false;
      this.showTittleDay = false;
      this.templateMonth = true;
      this.templateWeek = false;
      this.templateDay = false;
    },
    selectDay() {
      let monthYear = this.$refs.calendar.title.split(" ");
      this.tittleDay =
        monthYear[0] + " " + this.selectedDate.getDate() + ", " + monthYear[1];
      this.type = "day";
      this.showWeek = false;
      this.showTittleDay = true;
      this.templateMonth = false;
      this.templateWeek = false;
      this.templateDay = true;
    },
    updateDateSelected({ date }) {
      this.selectedDate = new Date(date + "T00:00:00");
    },
    updateDateMove(move) {
      if (move) {
        switch (this.type) {
          case "week":
            this.week++;
            break;
          case "day":
            this.selectedDate = new Date(
              this.selectedDate.setDate(this.selectedDate.getDate() + 1)
            );
            this.selectDay();
            break;

          default:
            break;
        }
      } else {
        switch (this.type) {
          case "week":
            this.week--;
            break;
          case "day":
            this.selectedDate = new Date(
              this.selectedDate.setDate(this.selectedDate.getDate() - 1)
            );
            this.selectDay();
            break;

          default:
            break;
        }
      }
    },
    editVisit(event) {
      this.editingVisit = true;
      this.dialog = true;
      this.selectedVisit = event;

      let dateAux = this.selectedVisit.start;

      this.visitShowed.start = dateAux;
      this.fases = [
        {
          idFase: this.selectedVisit.idFase,
          fase: this.selectedVisit.nombreFase
        }
      ];
      this.proyectos = [
        {
          idProyecto: this.selectedVisit.idProyecto,
          nombreProyecto: this.selectedVisit.nombreProyecto
        }
      ];
      this.visitShowed.ceco = {
        idCeco: this.selectedVisit.idCeco,
        ceco: this.selectedVisit.ceco + " - " + this.selectedVisit.idCeco
      };
      this.visitShowed.negocio = this.selectedVisit.negocio;
      this.visitShowed.fase = {
        idFase: this.selectedVisit.idFase,
        nombreFase: this.selectedVisit.nombreFase,
        ordenFase: this.selectedVisit.ordenFase
      };
      this.visitShowed.proyecto = {
        idProyecto: this.selectedVisit.idProyecto,
        nombreProyecto: this.selectedVisit.nombreProyecto,
        idAgrupa: this.selectedVisit.idAgrupa
      };
      this.visitShowed.start = dateAux;
      this.visitShowed.idUsuario = this.selectedVisit.idUsuario;
      this.visitShowed.nombre =
        this.selectedVisit.idUsuario +
        " - " +
        this.selectedVisit.nombreResponsable;
      this.visitShowed.timed = this.selectedVisit.timed;
      this.visitShowed.dotColor = this.selectedVisit.dotColor;
      this.proyectos = [];
      this.fases = [];

      this.proyectos.push(this.visitShowed.proyecto);
      this.fases.push(this.visitShowed.fase);
    },
    saveVisit() {
      let objAdd = {
        idUsuario: this.visitShowed.idUsuario,
        ceco: this.visitShowed.ceco.idCeco,
        idProyecto: this.visitShowed.proyecto.idProyecto,
        responsableAsigno: this.visitShowed.idUsuario,
        obsAsignacion: this.visitShowed.proyecto.negocio, //Viene en el proyecto
        idAgrupa: this.visitShowed.proyecto.idAgrupa, //Viene en el proyecto
        //fecha DDMMYYYY
        periodo:
          this.visitShowed.start.split("-")[2] +
          this.visitShowed.start.split("-")[1] +
          this.visitShowed.start.split("-")[0],
        faseActual: this.visitShowed.fase.ordenFase //idFase
      };

      axios
        .post("/asignacion/secure/post/altaAsignacion", objAdd)
        .then(response => {
          //SI RES
          if (response) {
            if (response.status === 200) {
              //VALIDAR CUANDO NO SE PUEDE ASIGNAR PORQUE ESTÁ DESACTIVA VALOR == 7
              this.editingVisit = false;
              this.edicionVisitaExitosa();

              this.getAsignaciones(this.startDate, this.endDate);
            } else {
              this.errorCreacionVisita();
            }
          }
        })
        .catch(error => {
          this.errorCreacionVisita();
        })
        .finally(function() {});
    },
    deleteVisit(event) {
      this.confirmacionEliminacionVisita();

      this.selectedVisit = event;

      //const ceco = e.path[3].children[0].innerHTML.split('-')[1].replace(/ /g,'');
      //const found = this.events.find(element => element.ceco === ceco);
      //this.selectedVisit = this.events.indexOf(found)
    },
    addVisit() {
      //console.log(JSON.stringify(this.visitShowed))
      let objAdd = {
        idUsuario: this.visitShowed.idUsuario,
        ceco: this.visitShowed.ceco,
        idProyecto: this.visitShowed.proyecto.idProyecto,
        responsableAsigno: this.visitShowed.idUsuario,
        obsAsignacion: this.visitShowed.proyecto.negocio, //Viene en el proyecto
        idAgrupa: this.visitShowed.proyecto.idAgrupa, //Viene en el proyecto
        //fecha DDMMYYYY
        periodo:
          this.visitShowed.start.split("-")[2] +
          this.visitShowed.start.split("-")[1] +
          this.visitShowed.start.split("-")[0],
        faseActual: this.visitShowed.fase.ordenFase //idFase
      };

      console.log(JSON.stringify(objAdd));

      axios
        .post("/asignacion/secure/post/altaAsignacion", objAdd)
        .then(response => {
          //SI RES
          if (response) {
            if (response.status === 200) {
              //VALIDAR CUANDO NO SE PUEDE ASIGNAR PORQUE ESTÁ DESACTIVA VALOR == 7
              this.editingVisit = false;
              this.creacionExitosaVista();

              this.getAsignaciones(this.startDate, this.endDate);
            }
          }
        })
        .catch(error => {
          this.errorCreacionVisita();
        })
        .finally(function() {});
    },
    edicionVisitaExitosa() {
      this.dialogContentInfo = {
        title: "Edición de visita exitosa",
        color: "#ffc900",
        img: "exito",
        text1: {
          text: "Se realizó la edición de la visita correctamente.",
          show: true,
          strong: true
        },
        text2: { text: "", show: true, strong: false },
        text3: { text: "", show: true, strong: false },
        secundaryBtn: false,
        secundaryBtnText: "",
        primaryBtnText: "Aceptar"
      };
      this.dialogContentInfo.text2.text = this.visitShowed.nombre;
      this.dialogContentInfo.text3.text =
        this.visitShowed.start +
        " " +
        this.visitShowed.sucursal +
        " / " +
        this.visitShowed.proyecto.nombreProyecto +
        " / " +
        this.visitShowed.fase.nombreFase;
      this.dialogInfo = true;
    },
    errorEdicionVisita() {
      this.dialogContentInfo = {
        title: "Error en edición de visita",
        color: "#ff7909",
        img: "error",
        text1: { text: "", show: false, strong: true },
        text2: {
          text:
            "Tuvimos problemas al guardar los cambios en la edición de la visita,",
          show: true,
          strong: false
        },
        text3: {
          text: "por favor reintentalo nuevamente.",
          show: true,
          strong: true
        },
        secundaryBtn: true,
        secundaryBtnText: "Cancelar",
        primaryBtnText: "Reintentar"
      };
      this.dialogInfo = true;
    },
    creacionExitosaVista() {
      this.dialogContentInfo = {
        title: "Creación exitosa de visita",
        color: "#ffca08",
        img: "exito2",
        text1: {
          text: "La visita se creó exitosamente",
          show: true,
          strong: true
        },
        text2: { text: "", show: false, strong: false },
        text3: { text: "", show: false, strong: true },
        secundaryBtn: false,
        secundaryBtnText: "",
        primaryBtnText: "Aceptar"
      };
      this.dialogInfo = true;
    },
    errorCreacionVisita() {
      this.dialogContentInfo = {
        title: "Error en creación de visita",
        color: "#ff7909",
        img: "error2",
        text1: {
          text: "Tuvimos problemas al crear la visita,",
          show: true,
          strong: false
        },
        text2: {
          text: "por favor reinténtalo nuevamente.",
          show: true,
          strong: true
        },
        text3: { text: "", show: false, strong: true },
        secundaryBtn: true,
        secundaryBtnText: "Cancelar",
        primaryBtnText: "Reintentar"
      };
      this.dialogInfo = true;
    },
    confirmacionEliminacionVisita() {
      this.dialogContentInfo = {
        title: "Confirmacón de eliminacion de visita",
        color: "#ff7909",
        img: "alert",
        text1: {
          text: "¿Estas seguro de eliminar la visita?",
          show: true,
          strong: true
        },
        text2: {
          text: "Recuerda que esta acción no es reversible.",
          show: true,
          strong: false
        },
        text3: { text: "", show: false, strong: true },
        secundaryBtn: true,
        secundaryBtnText: "No, cancelar",
        primaryBtnText: "Sí, eliminar"
      };
      this.dialogInfo = true;
    },

    confirmacionLiberacionFase() {
      this.dialogContentInfo = {
        title: "Confirmacón de liberación de fase",
        color: "#ff7909",
        img: "icoGuardar",
        text1: {
          text: "La fase tiene hallazgos pedientes por atender.",
          show: true,
          strong: false
        },
        text2: {
          text: "¿Estás seguro que deseas desbloquear la fase?",
          show: true,
          strong: true
        },
        text3: { text: "", show: false, strong: true },
        secundaryBtn: true,
        secundaryBtnText: "No, cancelar",
        primaryBtnText: "Sí, desbloquear"
      };
      this.dialogInfo = true;
    },
    dialogActions(e) {
      switch (e.target.innerText) {
        case "Sí, eliminar":
          this.eliminaAsignacion();
          break;
        case "Reintentar":
          this.dialog = true;
          break;

        default:
          break;
      }
    },
    validateForm() {
      //console.log(this.visitShowed)

      if (
        this.visitShowed.idUsuario === "" ||
        this.visitShowed.ceco === "" ||
        this.visitShowed.proyecto === "" ||
        this.visitShowed.fase === "" ||
        this.visitShowed.start === ""
      ) {
        this.activeButton = false;
      } else {
        this.activeButton = true;
      }
    },
    cleanForm() {
      this.visitShowed = {
        ceco: "",
        negocio: "",
        name: "",
        proyecto: "",
        start: "",
        sucursal: "",
        nombre: ""
      };

      this.activeButton = false;
    }
  }
};

Date.prototype.getWeek = function() {
  let date = new Date(this.getTime());
  date.setHours(0, 0, 0, 0);
  date.setDate(date.getDate() + 3 - ((date.getDay() + 6) % 7));
  let week1 = new Date(date.getFullYear(), 0, 4);
  return (
    1 +
    Math.round(
      ((date.getTime() - week1.getTime()) / 86400000 -
        3 +
        ((week1.getDay() + 6) % 7)) /
        7
    )
  );
};
</script>

<style>
@import url("../../../../assets/css/vuetifyComponents/calendar.css");
</style>
<style
  lang="scss"
  scoped
  src="../../../../assets/css/vuetifyComponents/selects.scss"
></style>
<style
  lang="scss"
  scoped
  src="../../../../assets/css/vuetifyComponents/inputs.scss"
></style>
<style
  lang="scss"
  scoped
  src="../../../../assets/css/vuetifyComponents/buttons.scss"
></style>
<style
  lang="scss"
  scoped
  src="../../../../assets/css/vuetifyComponents/forms.scss"
></style>
<style
  lang="scss"
  scoped
  src="../../../../assets/css/vuetifyComponents/group-button-toggle.scss"
></style>
<style
  lang="scss"
  scoped
  src="../../../../assets/css/vuetifyComponents/dialogs.scss"
></style>
<style
  lang="scss"
  scoped
  src="../../../../assets/css/vuetifyComponents/autocomplete.scss"
></style>
<style scoped>
.infoContainer {
  display: flex;
  flex-direction: column;
  align-items: center;
}

.imgDialogInfo {
  width: 110px;
  padding-bottom: 15px;
}

.strong {
  font-family: "AvenirNextLTPro-Medium";
}

.simbologiaContainer {
  width: 100%;
  background-color: #f4f4f4;
  height: 35px;
  display: flex;
  align-items: center;
  justify-content: space-around;
}
</style>
